<template>
    <div class="hours d-flex flex-wrap">
        <div class="hours__item">
            <span>From</span> 
            <b-form-select
                    
                v-model="quietHours.from"
                :options="options"
                size="sm"
                class="select_blue"
                @change="checkAvailable('from'), save()"
            />
        </div>
        <div class="hours__item">
            <span>To</span> 
            <b-form-select
                    
                v-model="quietHours.to"
                :options="options"
                size="sm"
                class="select_blue"
                @change="checkAvailable('to'), save()"
            />
        </div>
    </div>
</template>

<script>
import { QUIT_FULL_TIME } from '../../../../store/constants'
import {settings} from '@/mixins/settings'

export default {
    mixins: [settings],
    props: ['value'],
    data() {
        return {
            options: QUIT_FULL_TIME, 
            quietHours: {
                from: '00:00',
                to: '00:30',
                isActive: false,
            }
        }
    },
    created() {
        if(this.value) {
            if(this.value.from) this.quietHours.from = this.getValue(this.value.from)
            if(this.value.to) this.quietHours.to = this.getValue(this.value.to)
        }
        this.save()
    },
    methods: {
        save() {
            this.$emit('input', this.quietHours)
        },
        getValue(value) {
            if(value) {
                if(typeof value === 'string') {
                    const valueArr = value.includes(':') && value.split(':')
                    if(valueArr.length) return `${valueArr[0]}:${valueArr[1]}`
                    return '00:00'
                }
                if(value < 10) return `0${value}:00`
                return `${value}:00`
            } 
            return '00:00'
        },
        checkAvailable(type) {
            if(this.quietHours.from >= this.quietHours.to) {
                const optionsLength = this.options.length
                const lastOptionsIndex = optionsLength - 1
                const fromIndex = this.options.indexOf(this.quietHours.from)
                const toIndex = this.options.indexOf(this.quietHours.to)

                if(fromIndex == toIndex) {
                    if(type == 'from' && toIndex !== lastOptionsIndex) {
                        this.quietHours.to = this.options[toIndex + 1] 
                        this.quietHours.from = this.options[toIndex]
                    }
                    else if(type == 'from'){
                        this.quietHours.to = this.options[lastOptionsIndex]
                        this.quietHours.from = this.options[lastOptionsIndex - 1]
                    } 

                    if(type == 'to' && fromIndex !== 0) {
                        this.quietHours.from = this.options[fromIndex - 1]
                        this.quietHours.to = this.options[fromIndex]
                    }
                    else if(type == 'to'){
                        this.quietHours.to = this.options[1]
                        this.quietHours.from = this.options[0]
                    }
                }
            }
        },
    }
}
</script>

<style lang="scss" scoped>
.hours {
    &__item {
        max-width: 150px;
        margin-right: 32px;
        display: flex;
        align-items: center;
        &:last-child {
            margin-right: 0;
        }
        .select_blue {
            width: 102px;
            margin-left: 13px;
        }
    }
}
@media(max-width: 375px) {
    .hours {
        &__item {
            &:first-of-type {
                margin-bottom: 10px;
            }
            span {
                width: 35px;
                display: inline-block;
            }
        }
    }
}
</style> 